using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationPAYEVNTRequest2020
{
    public class PAYEVNT2020
    {        
        public bool RpCollectionExists = false;
        public int RpCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp
        /// PAYEVNT:pyin.02.40:SoftwareInformation.BusinessManagementSystem.Identifier
        /// </summary>
        public string PAYEVNT63 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp
        /// PAYEVNT:pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string PAYEVNT2 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp
        /// PAYEVNT:pyid.02.00:Identifiers.WithholdingPayerNumber.Identifier
        /// </summary>
        public string PAYEVNT3 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp
        /// PAYEVNT:pyde.02.00:OrganisationDetails.OrganisationBranch.Code
        /// </summary>
        public string PAYEVNT4 = null;

        public bool Rp_PreviousCollectionExists = false;
        public int Rp_PreviousCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Previous
        /// PAYEVNT:pyin.02.40:SoftwareInformation.BusinessManagementSystem.Identifier
        /// </summary>
        public string PAYEVNT101 = null;

        public bool Rp_OrganisationNameCollectionExists = false;
        public int Rp_OrganisationNameCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:OrganisationName
        /// PAYEVNT:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string PAYEVNT5 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:OrganisationName
        /// PAYEVNT:pyde.02.00:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string PAYEVNT6 = null;

        public bool Rp_ElectronicContactCollectionExists = false;
        public int Rp_ElectronicContactCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:ElectronicContact
        /// PAYEVNT:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
        /// </summary>
        public string PAYEVNT15 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:ElectronicContact
        /// PAYEVNT:pyde.02.00:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string PAYEVNT16 = null;

        public bool Rp_AddressDetailsPostalCollectionExists = false;
        public int Rp_AddressDetailsPostalCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:AddressDetailsPostal
        /// PAYEVNT:pyde.02.00:AddressDetails.Postcode.Text
        /// </summary>
        public string PAYEVNT12 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:AddressDetailsPostal
        /// PAYEVNT:pyde.02.08:AddressDetails.Country.Code
        /// </summary>
        public string PAYEVNT14 = null;

        public bool Rp_PayrollCollectionExists = false;
        public int Rp_PayrollCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll
        /// PAYEVNT:pyin.02.00:PaymentRecord.Transaction.Date
        /// </summary>
        public DateTime? PAYEVNT69 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll
        /// PAYEVNT:pyin.02.42:Interaction.Record.Count
        /// </summary>
        public decimal? PAYEVNT70 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll
        /// PAYEVNT:pyin.02.00:Message.Timestamp.Generation.Datetime
        /// </summary>
        public DateTime? PAYEVNT71 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll
        /// PAYEVNT:pyin.02.42:Interaction.Transaction.Identifier
        /// </summary>
        public string PAYEVNT84 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll
        /// PAYEVNT:pyin.02.28:Report.Amendment.Indicator
        /// </summary>
        public bool? PAYEVNT19 = null;

        public bool Rp_Payroll_IncomeTaxAndRemunerationCollectionExists = false;
        public int Rp_Payroll_IncomeTaxAndRemunerationCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll/:IncomeTaxAndRemuneration
        /// PAYEVNT:rvctc2.02.12:IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount
        /// </summary>
        public decimal? PAYEVNT20 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll/:IncomeTaxAndRemuneration
        /// PAYEVNT:lrla.02.23:Remuneration.TotalGrossPaymentsWithholding.Amount
        /// </summary>
        public decimal? PAYEVNT22 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll/:IncomeTaxAndRemuneration
        /// PAYEVNT:cssup.02.02:ChildSupport.Garnishee.Amount
        /// </summary>
        public decimal? PAYEVNT103 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Payroll/:IncomeTaxAndRemuneration
        /// PAYEVNT:cssup.02.02:ChildSupport.Withholding.Amount
        /// </summary>
        public decimal? PAYEVNT104 = null;

        public bool Rp_DeclarationCollectionExists = false;
        public int Rp_DeclarationCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Declaration
        /// PAYEVNT:pyin.02.56:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string PAYEVNT37 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Declaration
        /// PAYEVNT:pyin.02.29:Declaration.Signature.Date
        /// </summary>
        public DateTime? PAYEVNT38 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Rp/:Declaration
        /// PAYEVNT:pyin.02.28:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? PAYEVNT39 = null;

        public bool IntCollectionExists = false;
        public int IntCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Int
        /// PAYEVNT:pyid.02.00:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string PAYEVNT64 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Int
        /// PAYEVNT:pyid.02.00:Identifiers.TaxAgentNumber.Identifier
        /// </summary>
        public string PAYEVNT65 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Int
        /// PAYEVNT:pyde.02.00:PersonUnstructuredName.FullName.Text
        /// </summary>
        public string PAYEVNT68 = null;

        public bool Int_ElectronicContactCollectionExists = false;
        public int Int_ElectronicContactCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Int/:ElectronicContact
        /// PAYEVNT:pyde.02.00:ElectronicContact.ElectronicMail.Address.Text
        /// </summary>
        public string PAYEVNT66 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Int/:ElectronicContact
        /// PAYEVNT:pyde.02.00:ElectronicContact.Telephone.Minimal.Number
        /// </summary>
        public string PAYEVNT67 = null;

        public bool Int_DeclarationCollectionExists = false;
        public int Int_DeclarationCollectionCount = 0;
    
        /// <summary>
        /// /xbrli:xbrl/:Int/:Declaration
        /// PAYEVNT:pyin.02.56:Declaration.SignatoryIdentifier.Text
        /// </summary>
        public string PAYEVNT41 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Int/:Declaration
        /// PAYEVNT:pyin.02.29:Declaration.Signature.Date
        /// </summary>
        public DateTime? PAYEVNT42 = null;
    
        /// <summary>
        /// /xbrli:xbrl/:Int/:Declaration
        /// PAYEVNT:pyin.02.28:Declaration.StatementAccepted.Indicator
        /// </summary>
        public bool? PAYEVNT43 = null;

    }
}
